/* AMX Mod script.
*
* (c) Copyright 2002, OLO
* This file is provided as is (no warranties).
*
*/

#include <amxmod>

#define MAX_ADMINS	48

new admin_password[MAX_ADMINS][32]
new admin_name[MAX_ADMINS][32]
new admin_flags[MAX_ADMINS]
new admin_priv[MAX_ADMINS]
new admin_num = 0

public admin_cmd(){
	new data[32]
	read_argv(1,admin_name[admin_num],31)
	read_argv(2,admin_password[admin_num],31)
	read_argv(3,data,31)
	admin_priv[admin_num] = read_flags(data)
	read_argv(4,data,31)
	admin_flags[admin_num] = read_flags(data)
	admin_num++
	return PLUGIN_HANDLED
}

get_access(id,name[],authid[],ip[], password[]){
	new index = -1
	new result = 0
	for(new i = 0; i < admin_num; ++i) {
		if (admin_flags[i] & FLAG_AUTHID) {
			if (equal(authid,admin_name[i])) {
				index = i
				break
			}
		}
		else if (admin_flags[i] & FLAG_IP) {
			if (contain(ip,admin_name[i])!=-1){
				index = i
				break
			}
		}
		else {
			if (admin_flags[i] & FLAG_TAG)	{
				if (contain(name,admin_name[i])!=-1){
					index = i
					break
				}
			}
			else if (equal(name,admin_name[i])) {
				index = i
				break
			}
		}
	}
	if (index != -1) {
		if (admin_flags[index] & FLAG_NOPASS){
			result |= 8
			set_user_flags(id,admin_priv[index])
			log_to_file("addons/amx/admin.log","^"%s<%d><%s><>^" triggered ^"access_level_nopw^" (level ^"%d^") (address ^"%s^")",
				name,get_user_userid(id),authid,admin_priv[index],ip)
		}
		else if (equal(password,admin_password[index])) {
			result |= 12
			set_user_flags(id,admin_priv[index])
			log_to_file("addons/amx/admin.log","^"%s<%d><%s><>^" triggered ^"access_level^" (level ^"%d^") (address ^"%s^")",
				name,get_user_userid(id),authid,admin_priv[index],ip)
		}
		else {
			result |= 1
			if (admin_flags[index] & FLAG_KICK)
				result |= 2
		}
	}
	else if (get_cvar_float("amx_mode")==2.0) {
		result |= 2
	}
	else {
		new defaccess[32]
		get_cvar_string("amx_default_access",defaccess,31)
		new idefaccess = read_flags(defaccess)
		if (idefaccess){
			result |= 8
			set_user_flags(id,idefaccess)
		}
  } 	
	
	return result
}

public client_connect(id){
	if (!get_cvar_float("amx_mode"))
		return PLUGIN_CONTINUE
	remove_user_flags(id)
	new userip[32],username[32],userauthid[32],password[32],passfield[32]
	get_user_ip(id,userip,31)
	get_user_name(id,username,31)
	get_user_authid(id,userauthid,31)
	get_cvar_string("amx_password_field",passfield,31)
	get_user_info(id,passfield,password,31)
	new result = get_access(id,username,userauthid,userip,password)
	if (result & 1)	client_cmd(id,"echo * Invalid Password!")
	if (result & 2)	{
		client_cmd(id,"echo * You have no entry to the server...;disconnect")
		return PLUGIN_HANDLED
	}
	if (result & 4) client_cmd(id,"echo * Password accepted")
	if (result & 8)	client_cmd(id,"echo * Privileges set")
	return PLUGIN_CONTINUE
}

public plugin_init(){
	register_plugin("Admin Base","0.8","default")
	register_srvcmd("amx_admin","admin_cmd")
	register_cvar("amx_mode","2.0")
	register_cvar("amx_password_field","_pw")
	register_cvar("amx_default_access","") 
	server_cmd("exec addons/amx/admin.cfg")
	return PLUGIN_CONTINUE
}
