/* AMX Mod script.
 *
 * (c) Copyright 2002, OLO
 * This file is provided as is (no warranties).
 *
 */

#include <amxmod>
#include <amxmisc>

/*  NOTE: Works only with 0.8.3 and higher!!!
 *
 *  cmds:
 *  amx_off - pause plugins not listed in dpause_list
 *  amx_on - enable all plugins not listed in dpause_list
 *
 *  access to commands is with "m" flag (ADMIN_LEVEL_A)
 */


/* 
 *  Put here titles of plugins which you don't want to pause. 
 */
 
#define PLG_IN_LIST 10
new dpause_list[PLG_IN_LIST][]= {
	"Pause Plugins",
	"Admin Commands",
	"TimeLeft",
	"Slots Reservation",
	"Admin Chat",
	"NextMap",
	"Admin Menu",
	"Admin Help",
	"Admin Base",
	"Welcome Message"
}

bool:dont_pause(name[]) {
	for(new a=0;a<PLG_IN_LIST;++a)
		if (equal(dpause_list[a],name))
			return true
	return false
}

public pause_all(id,level,cid){
	if (!cmd_access(id,level,cid,1))
		return PLUGIN_HANDLED
	new filename[32],title[32],version[2],author[2],status[2]
	new count = 0, imax = get_pluginsnum()
	for (new a=0;a<imax;++a){
		get_plugin(a,filename,31,title,31,version,0,author,0,status,1)
		if (dont_pause(title)||status[0]!='r') continue
		pause("ac",filename)
		++count
		console_print(id,"Pausing %s (file ^"%s^")",title,filename)
	}
	console_print(id,"Paused %d plugins",count)	
	return PLUGIN_HANDLED
}

public unpause_all(id,level,cid){
	if (!cmd_access(id,level,cid,1))
		return PLUGIN_HANDLED
	new filename[32],title[32],version[2],author[2],status[2]
	new count = 0, imax = get_pluginsnum()
	for (new a=0;a<imax;++a){
		get_plugin(a,filename,31,title,31,version,0,author,0,status,1)
		if (dont_pause(title)||status[0]!='p') continue
		unpause("ac",filename)
		++count
		console_print(id,"Unpausing %s (file ^"%s^")",title,filename)
	}
	console_print(id,"Unpaused %d plugins",count)	
	return PLUGIN_HANDLED
}

public plugin_init(){
	register_plugin("Pause Plugins","0.8","default")
	register_concmd("amx_off","pause_all",ADMIN_LEVEL_A," - pause some plugins")
	register_concmd("amx_on","unpause_all",ADMIN_LEVEL_A," - unpause some plugins")
	return PLUGIN_CONTINUE
}